// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_FBPVariableDescription.h"
#include "ISCW_UEdGraphNode.h"
#include "ISCW_UK2Node_FunctionTerminator.h"
#include <memory>
#include <string>
#include <vector>

using std::shared_ptr;
using std::vector;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UK2Node_FunctionEntry : public virtual ISCW_UK2Node_FunctionTerminator
	{
	public:
		virtual ~ISCW_UK2Node_FunctionEntry() = default;

		virtual shared_ptr<ISCW_UEdGraphNode> AsUEdGraphNode() const = 0;

		virtual shared_ptr<ISCW_UK2Node_FunctionTerminator> AsUK2Node_FunctionTerminator() const = 0;

		virtual bool GetCanRenameNode() const = 0;

		virtual vector<ISCW_FBPVariableDescriptionPtr> GetLocalVariables() const = 0;

		virtual void SetExtraFlags(int32_t InFlags) = 0;
	};

	using ISCW_UK2Node_FunctionEntryConstPtr = shared_ptr<const ISCW_UK2Node_FunctionEntry>;
	using ISCW_UK2Node_FunctionEntryPtr = shared_ptr<ISCW_UK2Node_FunctionEntry>;
} // namespace Sourcify